!function(){define("PriorityQueue/AbstractPriorityQueue",[],function(){var t;return t=function(){function t(t){if(null==(null!=t?t.strategy:void 0))throw"Must pass options.strategy, a strategy";if(null==(null!=t?t.comparator:void 0))throw"Must pass options.comparator, a comparator";this.priv=new t.strategy(t),this.length=0}return t.prototype.queue=function(t){return this.length++,this.priv.queue(t),void 0},t.prototype.dequeue=function(){if(!this.length)throw"Empty queue";return this.length--,this.priv.dequeue()},t.prototype.peek=function(){if(!this.length)throw"Empty queue";return this.priv.peek()},t}()})}.call(this),function(){define("PriorityQueue/ArrayStrategy",[],function(){var t,i;return i=function(t,i,e){var r,a,o;for(a=0,r=t.length;r>a;)o=a+r>>>1,e(t[o],i)>=0?a=o+1:r=o;return a},t=function(){function t(t){var i;this.options=t,this.comparator=this.options.comparator,this.data=(null!=(i=this.options.initialValues)?i.slice(0):void 0)||[],this.data.sort(this.comparator).reverse()}return t.prototype.queue=function(t){var e;return e=i(this.data,t,this.comparator),this.data.splice(e,0,t),void 0},t.prototype.dequeue=function(){return this.data.pop()},t.prototype.peek=function(){return this.data[this.data.length-1]},t}()})}.call(this),function(){define("PriorityQueue/BinaryHeapStrategy",[],function(){var t;return t=function(){function t(t){var i;this.comparator=(null!=t?t.comparator:void 0)||function(t,i){return t-i},this.length=0,this.data=(null!=(i=t.initialValues)?i.slice(0):void 0)||[],this._heapify()}return t.prototype._heapify=function(){var t,i,e;if(this.data.length>0)for(t=i=1,e=this.data.length;e>=1?e>i:i>e;t=e>=1?++i:--i)this._bubbleUp(t);return void 0},t.prototype.queue=function(t){return this.data.push(t),this._bubbleUp(this.data.length-1),void 0},t.prototype.dequeue=function(){var t,i;return i=this.data[0],t=this.data.pop(),this.data.length>0&&(this.data[0]=t,this._bubbleDown(0)),i},t.prototype.peek=function(){return this.data[0]},t.prototype._bubbleUp=function(t){for(var i,e;t>0&&(i=t-1>>>1,this.comparator(this.data[t],this.data[i])<0);)e=this.data[i],this.data[i]=this.data[t],this.data[t]=e,t=i;return void 0},t.prototype._bubbleDown=function(t){var i,e,r,a,o;for(i=this.data.length-1;;){if(e=(t<<1)+1,a=e+1,r=t,i>=e&&this.comparator(this.data[e],this.data[r])<0&&(r=e),i>=a&&this.comparator(this.data[a],this.data[r])<0&&(r=a),r===t)break;o=this.data[r],this.data[r]=this.data[t],this.data[t]=o,t=r}return void 0},t}()})}.call(this),function(){define("PriorityQueue/BHeapStrategy",[],function(){var t;return t=function(){function t(t){var i,e,r,a,o,n,s,h,u;for(this.comparator=(null!=t?t.comparator:void 0)||function(t,i){return t-i},this.pageSize=(null!=t?t.pageSize:void 0)||512,this.length=0,r=0;1<<r<this.pageSize;)r+=1;if(1<<r!==this.pageSize)throw"pageSize must be a power of two";for(this._shift=r,this._emptyMemoryPageTemplate=i=[],e=o=0,h=this.pageSize;h>=0?h>o:o>h;e=h>=0?++o:--o)i.push(null);if(this._memory=[],this._mask=this.pageSize-1,t.initialValues)for(u=t.initialValues,n=0,s=u.length;s>n;n++)a=u[n],this.queue(a)}return t.prototype.queue=function(t){return this.length+=1,this._write(this.length,t),this._bubbleUp(this.length,t),void 0},t.prototype.dequeue=function(){var t,i;return t=this._read(1),i=this._read(this.length),this.length-=1,this.length>0&&(this._write(1,i),this._bubbleDown(1,i)),t},t.prototype.peek=function(){return this._read(1)},t.prototype._write=function(t,i){var e;for(e=t>>this._shift;e>=this._memory.length;)this._memory.push(this._emptyMemoryPageTemplate.slice(0));return this._memory[e][t&this._mask]=i},t.prototype._read=function(t){return this._memory[t>>this._shift][t&this._mask]},t.prototype._bubbleUp=function(t,i){var e,r,a,o;for(e=this.comparator;t>1&&(r=t&this._mask,t<this.pageSize||r>3?a=t&~this._mask|r>>1:2>r?(a=t-this.pageSize>>this._shift,a+=a&~(this._mask>>1),a|=this.pageSize>>1):a=t-2,o=this._read(a),!(e(o,i)<0));)this._write(a,i),this._write(t,o),t=a;return void 0},t.prototype._bubbleDown=function(t,i){var e,r,a,o,n;for(n=this.comparator;t<this.length;)if(t>this._mask&&!(t&this._mask-1)?e=r=t+2:t&this.pageSize>>1?(e=(t&~this._mask)>>1,e|=t&this._mask>>1,e=e+1<<this._shift,r=e+1):(e=t+(t&this._mask),r=e+1),e!==r&&r<=this.length)if(a=this._read(e),o=this._read(r),n(a,i)<0&&n(a,o)<=0)this._write(e,i),this._write(t,a),t=e;else{if(!(n(o,i)<0))break;this._write(r,i),this._write(t,o),t=r}else{if(!(e<=this.length))break;if(a=this._read(e),!(n(a,i)<0))break;this._write(e,i),this._write(t,a),t=e}return void 0},t}()})}.call(this),function(){var t={}.hasOwnProperty,i=function(i,e){function r(){this.constructor=i}for(var a in e)t.call(e,a)&&(i[a]=e[a]);return r.prototype=e.prototype,i.prototype=new r,i.__super__=e.prototype,i};define("PriorityQueue",["./PriorityQueue/AbstractPriorityQueue","./PriorityQueue/ArrayStrategy","./PriorityQueue/BinaryHeapStrategy","./PriorityQueue/BHeapStrategy"],function(t,e,r,a){var o;return o=function(t){function e(t){t||(t={}),t.strategy||(t.strategy=r),t.comparator||(t.comparator=function(t,i){return(t||0)-(i||0)}),e.__super__.constructor.call(this,t)}return i(e,t),e}(t),o.ArrayStrategy=e,o.BinaryHeapStrategy=r,o.BHeapStrategy=a,o})}.call(this);